# file      : build/frame.make
# author    : Boris Kolpackov <boris@kolpackov.net>
# copyright : Copyright (c) 2004 Boris Kolpackov
# license   : GNU GPL v2; http://www.gnu.org/licenses/gpl.txt

%reserved% := SHELL MAKEFILE_LIST MAKEFLAGS include

# return only vars with 'file' origin
#
define frame-vars-stage-1
$(foreach v,$(.VARIABLES),$(if $(findstring file,$(origin $v)),$v))
endef

# return only vars which don't contain '-'
#
define frame-vars-stage-2
$(foreach v,$(call frame-vars-stage-1),$(if $(findstring -,$v),,$v))
endef

# $1 holds exclusion list
#
define frame-vars
$(filter-out \%% $(%reserved%) $1,$(call frame-vars-stage-2))
endef


%frame% := %frame

#@@ should I use := or =? This is a tricky question.
#

define frame-save
$(%frame%)/$1% := $(value $1)
endef

define frame-restore
$(eval $$1 := $$(value $$(%frame%)/$$1%))
endef

#@@ It would be cleaner to have something like 'undefine' but
#   this is good enough for now.
#
define frame-undefine
$(eval $$1 :=)
endef

#@@ use debug messages to check for garbage being framed.
#

#$$(warning framing $$(value $(%frame%)_vars%))
define frame-enter-body
$(%frame%)_vars% := $(call frame-vars,$1)
$(%frame%)_excl% := $1
$$(foreach v,$$(value $(%frame%)_vars%),$$(eval $$(call frame-save,$$v)))
%frame% := $(%frame%)/frame
endef

define frame-enter
$(eval $(call frame-enter-body,$1))
endef


#$$(warning restoring $$(value $$(%frame%)_vars%))
define frame-leave-body
%frame% := $(patsubst %/,%,$(dir $(%frame%)))
$$(foreach v,$$(value $$(%frame%)_vars%),$$(call frame-restore,$$v))
$$(foreach v,\
$$(filter-out $$(value $$(%frame%)_vars%),$$(call frame-vars,$$(value $$(%frame%)_excl%))),\
$$(call frame-undefine,$$v))
endef

define frame-leave
$(eval $(call frame-leave-body))
endef
